/*
_________________________________________________________

S I M P L E   R S S   F E E D   R E A D E R
Ron Kessler
Created 1/2/2017

C++/CLI Version

This demo shows how to get RSS feeds and display
in a WebBrowser Control in a Standard Desktop app.

Add a panel control and dock it to the top of your form.
Add the buttons/controls you see and name them.

Add a Webbrowser control from the toolbox and dock it to the form
using the fill enumeration in the dock property.

I have it start on the CNN rss feed by default but you can copy in
any URL and click GO to take you there.
_________________________________________________________
Updated 1/3/2017 to suppress JS error messages
*/

#pragma once

namespace WindowsApplication1 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;


	//---add these. Also add a new Reference for System.ServiceModel
	using namespace System::ServiceModel::Syndication;
	using namespace System::Xml;

	/// <summary>
	/// Summary for frmMain
	/// </summary>
	public ref class frmMain : public System::Windows::Forms::Form
	{
	public:
		frmMain(void)
		{
			InitializeComponent();
			this->CenterToScreen ();
		}

#pragma region Windows Form Designer generated code
	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~frmMain()
		{
			if (components)
			{
				delete components;
			}
		}
		private: System::Windows::Forms::Panel^  panel1;
		protected:
		private: System::Windows::Forms::Button^  btnGo;
		private: System::Windows::Forms::TextBox^  txtURL;
		private: System::Windows::Forms::Label^  label1;
		private: System::Windows::Forms::Button^  btnForward;
		private: System::Windows::Forms::Button^  btnBack;
		private: System::Windows::Forms::WebBrowser^  webBrowser1;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;


		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->panel1 = ( gcnew System::Windows::Forms::Panel () );
			this->btnGo = ( gcnew System::Windows::Forms::Button () );
			this->txtURL = ( gcnew System::Windows::Forms::TextBox () );
			this->label1 = ( gcnew System::Windows::Forms::Label () );
			this->btnForward = ( gcnew System::Windows::Forms::Button () );
			this->btnBack = ( gcnew System::Windows::Forms::Button () );
			this->webBrowser1 = ( gcnew System::Windows::Forms::WebBrowser () );
			this->panel1->SuspendLayout ();
			this->SuspendLayout ();
			// 
			// panel1
			// 
			this->panel1->Controls->Add (this->btnGo);
			this->panel1->Controls->Add (this->txtURL);
			this->panel1->Controls->Add (this->label1);
			this->panel1->Controls->Add (this->btnForward);
			this->panel1->Controls->Add (this->btnBack);
			this->panel1->Dock = System::Windows::Forms::DockStyle::Top;
			this->panel1->Location = System::Drawing::Point (0, 0);
			this->panel1->Name = L"panel1";
			this->panel1->Size = System::Drawing::Size (1045, 43);
			this->panel1->TabIndex = 3;
			// 
			// btnGo
			// 
			this->btnGo->BackColor = System::Drawing::Color::Green;
			this->btnGo->ForeColor = System::Drawing::Color::White;
			this->btnGo->Location = System::Drawing::Point (717, 1);
			this->btnGo->Name = L"btnGo";
			this->btnGo->Size = System::Drawing::Size (75, 40);
			this->btnGo->TabIndex = 4;
			this->btnGo->Text = L"GO";
			this->btnGo->UseVisualStyleBackColor = false;
			this->btnGo->Click += gcnew System::EventHandler (this, &frmMain::btnGo_Click);
			// 
			// txtURL
			// 
			this->txtURL->Location = System::Drawing::Point (282, 13);
			this->txtURL->Name = L"txtURL";
			this->txtURL->Size = System::Drawing::Size (429, 22);
			this->txtURL->TabIndex = 3;
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point (190, 13);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size (74, 17);
			this->label1->TabIndex = 2;
			this->label1->Text = L"Enter URL";
			// 
			// btnForward
			// 
			this->btnForward->Location = System::Drawing::Point (94, 0);
			this->btnForward->Name = L"btnForward";
			this->btnForward->Size = System::Drawing::Size (75, 40);
			this->btnForward->TabIndex = 1;
			this->btnForward->Text = L"Forward";
			this->btnForward->UseVisualStyleBackColor = true;
			this->btnForward->Click += gcnew System::EventHandler (this, &frmMain::btnForward_Click);
			// 
			// btnBack
			// 
			this->btnBack->Location = System::Drawing::Point (13, 0);
			this->btnBack->Name = L"btnBack";
			this->btnBack->Size = System::Drawing::Size (75, 40);
			this->btnBack->TabIndex = 0;
			this->btnBack->Text = L"Back";
			this->btnBack->UseVisualStyleBackColor = true;
			this->btnBack->Click += gcnew System::EventHandler (this, &frmMain::btnBack_Click);
			// 
			// webBrowser1
			// 
			this->webBrowser1->Dock = System::Windows::Forms::DockStyle::Fill;
			this->webBrowser1->Location = System::Drawing::Point (0, 0);
			this->webBrowser1->MinimumSize = System::Drawing::Size (20, 20);
			this->webBrowser1->Name = L"webBrowser1";
			this->webBrowser1->Size = System::Drawing::Size (1045, 603);
			this->webBrowser1->TabIndex = 2;
			// 
			// frmMain
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF (8, 16);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size (1045, 603);
			this->Controls->Add (this->panel1);
			this->Controls->Add (this->webBrowser1);
			this->Margin = System::Windows::Forms::Padding (4);
			this->Name = L"frmMain";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"Simple RSS Feed Reader (C++ Version)";
			this->Load += gcnew System::EventHandler (this, &frmMain::frmMain_Load);
			this->panel1->ResumeLayout (false);
			this->panel1->PerformLayout ();
			this->ResumeLayout (false);

			}
#pragma endregion


		//*************START OF MY CODE******************

		//---property to hold the URL
		private:	property String^ url;

		private: System::Void frmMain_Load (System::Object^  sender, System::EventArgs^  e)
			{
			//---to get started
			url = "http://rss.cnn.com/rss/cnn_tech.rss";
			GetRSSFeed (url);

			}
	private: System::Void btnBack_Click (System::Object^  sender, System::EventArgs^  e)
		{
			//---is there any browser history?
			if (webBrowser1->CanGoBack)
				webBrowser1->GoBack ();
		}
	private: System::Void btnForward_Click (System::Object^  sender, System::EventArgs^  e)
		{
		if (webBrowser1->CanGoForward)
			webBrowser1->GoForward ();
		}
	private: System::Void btnGo_Click (System::Object^  sender, System::EventArgs^  e)
		{
			//---make sure they type in something!
			if (txtURL->Text->Trim()->Length > 0)
				GetRSSFeed (url);

		}

		private: void GetRSSFeed (String^ whichURL)
		{

			//---make it so! We use an XML reader similar to a StreamReader
			XmlReader^ reader = XmlReader::Create (url);
			SyndicationFeed^ myFeed = SyndicationFeed::Load(reader);
			reader->Close ();

			webBrowser1->ScriptErrorsSuppressed = true;  //no JS error boxes
			webBrowser1->Navigate (url);      //now show it

		}
};
}
